



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 2544 最短路 最短路问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 2544 最短路 最短路问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:16:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>解题报告：</p>
<p>这题就是求两个单源点之间的最小距离，属于最短路问题，由于数据量很小，只有100，所以这题可以用弗洛伊德也可以用迪杰斯特拉，都可以过，但是用迪杰斯特拉会快一点，但用弗洛伊德的代码会稍短一点，纯属裸的算法题，这里给出两种算法的代码：</p>
<p>弗洛伊德算法:</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;iostream&gt;<br />
 const int MAX = 0xfffff;<br />
 int map[][];<br />
 int main() {<br />
     int N,M,x,y,z;<br />
     while(scanf("%d%d",&amp;N,&amp;M)&amp;&amp;(N||M)) {<br />
         for(int i = ;i&lt;=N;++i)<br />
         for(int j = ;j&lt;=N;++j)<br />
         map[i][j] = (i==j? :MAX);<br />
         for(int i  = ;i&lt;=M;++i) {<br />
             scanf("%d%d%d",&amp;x,&amp;y,&amp;z);<br />
             map[x][y] = map[y][x] = z;<br />
         }<br />
         for(int i = ;i&lt;=N;++i)<br />
         for(int j = ;j&lt;=N;++j)<br />
         for(int k = ;k&lt;=N;++k)<br />
         map[j][k] = std::min(map[j][k],map[j][i]+map[i][k]);<br />
         printf("%d\n",map[][N]);<br />
     }<br />
     return ;<br />
 }
     </pre>
</div></div>
<p>迪杰斯特拉：</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;iostream&gt;<br />
 #include&lt;cstring&gt;<br />
 const int MAX = 0xffff;<br />
 int map[][],T[],visit[];<br />
 int main() {<br />
     int N,M,x,y,z;<br />
     while(scanf("%d%d",&amp;N,&amp;M)&amp;&amp;(N||M)) {<br />
         for(int i = ;i&lt;=N;++i) {<br />
             T[i] = MAX;<br />
             for(int j = ;j&lt;=N;++j)<br />
             map[i][j] = MAX;<br />
         }<br />
         for(int i = ;i&lt;=M;++i) {<br />
             scanf("%d%d%d",&amp;x,&amp;y,&amp;z);<br />
             map[x][y] = map[y][x] = z;<br />
         }<br />
         memset(visit,,sizeof(visit));<br />
         T[] = ;<br />
         int s = ;<br />
         while() {<br />
             if(s==N)<br />
             break;<br />
             for(int i = ;i&lt;=N;++i)<br />
             T[i] = std::min(T[i],T[s]+map[s][i]);<br />
             visit[s] = ;<br />
             int Min = MAX;<br />
             for(int i = ;i&lt;=N;++i)<br />
             if(!visit[i]&amp;&amp;(T[i]&lt;Min)) {<br />
                 s = i;<br />
                 Min = T[i];<br />
             }<br />
         }<br />
         printf("%d\n",T[N]);<br />
     }<br />
     return ;<br />
 }
             </pre>
</div></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwl24k9.html">微信小程序之小豆瓣图书</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pkpry8.html">WordPress基础：小工具的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2m74w8.html">maven创建子项目&lpar;适用于多模块管理项目&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnwkjxq.html">oracle数据库导入、导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3xleq.html">【摘】【网络】无线AP与无线路由器有什么区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrg2r9.html">PHP代码审计中你不知道的牛叉技术点</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r36349.html">lintcode  75 Find Peak Element</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p42md9.html">redis与memcached比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw2krlq.html">从源代码分析Universal-Image-Loader中的线程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p02yyq.html">State Pattern -- 状态模式原理及实现（C&plus;&plus;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1emkz9.html">浅谈html语义化标签&comma;Html5新增语义化标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ooj149.html">Linux链接库四（多个库文件链接顺序问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e14ojx9.html">phpize的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnw73q.html">谨以此错误警醒自己---java&period;lang&period;ClassNotFoundException&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdx3wd8.html">Objective-C基础之&HorizontalLine;&HorizontalLine;多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zovkd1q.html">js解析php返回的json数据无法获取length的问题分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zk2ke9.html">DOM详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mev6koq.html">toggle的用法（点击更换不同的function）当指定元素被点击时，在两个或多个函数之间轮流切换。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0m6v9.html">java 接口1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv221z19.html">Codeforces Educational Codeforces Round 44 &lpar;Rated for Div&period; 2&rpar; E&period; Pencils and Boxes</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gp17x79.html">Week11分数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjm0368.html">mark1-git</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vm14zq.html">RYU 灭龙战 second day（内容大部分引自网络）</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1e6d09.html">关于Python  matplotlib显示汉字乱码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7expwk9.html">MyBatis关联查询，一对一关联查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm0j1w9.html">codeforces1A</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn1v62q.html">2019&period;2&period;28&amp;amp&semi;2019&period;3&period;1 考试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kw5z3q.html">POJ 3660 Cow Contest &sol; HUST 1037 Cow Contest &sol; HRBUST 1018 Cow Contest（图论，传递闭包）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em1m7k9.html">jq禁用html标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjejnzq.html">Redis在window上安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
